import math
from random import randint

GRAD = math.pi / 180


def radians_to_degrees(radians):
    return (radians / math.pi) * 180.0


def normalize(v):
    v_mag = magnitude(v)
    return [v[i]/v_mag for i in range(len(v))]


def magnitude(v):
    return math.sqrt(sum(v[i]*v[i] for i in range(len(v))))


def distance(u, v):
    dist1 = u[0] - u[1]
    dist2 = v[0] - v[1]
    return math.sqrt(dist1*dist1 + dist2 * dist2)


def add(u, v):
    return [u[i]+v[i] for i in range(len(u))]


def sub(u, v):
    return [u[i]-v[i] for i in range(len(u))]


def scale(u, scalar):
    return [u[i]*scalar for i in range(len(u))]


def sign(x):
    if not x:
        return 0
    if x > 0:
        return 1
    if x < 0:
        return -1


def random_sign():
    signs = (-1, 1)
    return signs[randint(0, 1)]

