from Core.Parts.Part import Part


class AudioSourcePart(Part):
    def __init__(self, sound, fade_in_ms=250, fade_out_ms=250):
        super().__init__()
        self._playing = False
        self._play_time = 0
        self._sound = sound
        self._fade_in_ms = fade_in_ms
        self._fade_out_ms = fade_out_ms

        self._playing_in_loop = False
        self._loop_time = 0
        self._play_time = 0

    def start_playback(self, loop=False):
        if not self._playing:
            if loop:
                self._sound.play(self._fade_in_ms, 10000)
                self._loop_time = 10
                self._play_time = 0
            else:
                self._sound.play()
            self._playing = True
            self._playing_in_loop = loop

    # TODO: find out how to stop infinite looped sound so code below will be unnecessary
    def update(self, delta):
        if self._playing and self._playing_in_loop:
            self._play_time += delta
            if self._play_time >= self._loop_time:
                self._play_time = 0
                self._sound.play(self._fade_in_ms, 10000)

    def stop_playback(self):
        if self._playing:
            self._sound.fadeout(250)
            self._playing = False

    def set_volume(self, vol):
        self._sound.set_volume(vol)

    def cleanup(self):
        self._sound.stop()

