from Core.Parts.BaseColliderPart import BaseColliderPart, ColliderType
from Core.Parts.SpritePart import SpritePart
from Core.Parts.TransformPart import TransformPart


class BoxColliderPart(BaseColliderPart):
    def __init__(self, collision_layer):
        super().__init__(ColliderType.Box)
        self.layer = collision_layer
        self.rect_inflate = None

    def initialize(self):
        self.sprite = self.entity.get(SpritePart)
        self.transform = self.entity.get(TransformPart)

    @property
    def rect(self):
        if self.rect_inflate:
            return self.sprite.rect.inflate(*self.rect_inflate)
        return self.sprite.rect
