from Core.Parts.BaseColliderPart import BaseColliderPart, ColliderType
from Core.Parts.SpritePart import SpritePart
from Core.Parts.TransformPart import TransformPart


class CircleColliderPart(BaseColliderPart):
    def __init__(self, collision_layer, sprite_dim_used='width'):
        super().__init__(ColliderType.Circle)
        self.layer = collision_layer
        self.radius = 0
        self.position = (0, 0)
        self.sprite_dim_used = sprite_dim_used

    def initialize(self):
        self.sprite = self.entity.get(SpritePart)
        self.radius = 0

        if self.sprite_dim_used == 'width':
            self.radius = self.sprite.rect.width / 2
        else:
            self.radius = self.sprite.rect.height / 2

        self.radius *= 0.95

        self.position = self.sprite.entity.get(TransformPart).position
