from Core.EventManager import Event
from Core.Parts.Part import Part


class HealthPart(Part):
    def __init__(self, max_health):
        super().__init__()
        self.max_health = max_health
        self.health = max_health

    def initialize(self):
        self.health = self.max_health

    @property
    def is_alive(self):
        return self.health > 0

    def take_hit(self, dmg):
        self.health -= dmg
        self.entity.event_manager.invoke(Event.ENTITY_TOOK_HIT, self.entity)

        if not self.is_alive:
            self.entity.event_manager.invoke(Event.ENTITY_DEAD, self.entity)

    def heal(self, amount):
        self.health = amount
        self.health = min(self.health, self.max_health)
