from Core.Parts.BoxColliderPart import BoxColliderPart
from Core.Parts.HealthPart import HealthPart
from Core.Parts.ProjectilePart import ProjectilePart


class MissileControlPart(ProjectilePart):
    def __init__(self, entity_manager, damage, sounds):
        super().__init__(damage)
        self.entity_manager = entity_manager
        self.lifetime = 0.0
        self.arming_time = 0.5
        self.armed = False
        self.impact_sound = sounds['impact']
        self.launch_sound = sounds['launch']

    def initialize(self):
        self.collider = self.entity.get(BoxColliderPart)
        self.collider.rect_inflate = (-2, -7)
        self.launch_sound.start_playback()

    def update(self, delta):
        self.lifetime += delta
        if self.lifetime > self.arming_time:
            self.armed = True

    def on_collision_with(self, other_collider):
        if self.armed:
            self.impact_sound.start_playback()
            self.launch_sound.stop_playback()
            self.entity_manager.remove(self.entity)
            if other_collider.entity.has(HealthPart):
                other_health = other_collider.entity.get(HealthPart)
                other_health.take_hit(self.damage)
