from Core.Parts.Part import Part
from Core.Parts.SpritePart import SpritePart
from Core.Parts.TransformPart import TransformPart


class PlanetPart(Part):

    def __init__(self, spin_speed, spin_direction):
        super().__init__()
        self.spin_speed = spin_speed
        self.spin_dir = spin_direction
        self.angle = 0
        self.original = None

    def initialize(self):
        self.sprite = self.entity.get(SpritePart)
        self.transform = self.entity.get(TransformPart)
        self.original = self.sprite.dirty_sprite.image

    def update(self, delta):
        added = self.spin_speed * self.spin_dir * delta
        self.angle += added
        if self.angle >= 360:
            self.angle = 0
        elif self.angle <= 0:
            self.angle = 360
        else:
            self.transform.rotate_to(self.angle)
